<?php
/* ================================================================================== */
/*      Blog Shortcode
/* ================================================================================== */

function waves_blog($atts, $content) {
    global $tw_isshortcode;
    $tw_isshortcode='true';
    $atts = shortcode_atts(array(
        'size'  => 'col-md-3',
        'class' => '',
        'title' => '',
        'layout'    => 'simple',
        'post_count'    => get_option('posts_per_page'),
        'category_ids'  => '',
        'pagination'    => 'true',
        'excerpt_count' => '',
        'more_text'     => __('Continue Reading','waves'),
    ), $atts);
    
    $output = waves_item($atts,'waves-blog '.$atts['layout'].'-blog');
    
    if($atts['layout']=='grid') {
        add_action('wp_footer', 'waves_portfolio_script');
        $class = 'col-md-4';
        $start = '<div class="row">';
        $end = '</div>';
    } else {
        $class = $start = $end = '';
    }
    if ( get_query_var('paged') ) {
        $paged = get_query_var('paged');
    } elseif ( get_query_var('page') ) {
        $paged = get_query_var('page');
    } else {
        $paged = 1;
    }
    $query = Array(
        'post_type' => 'post',
        'posts_per_page' => $atts['post_count'],
        'paged' => $paged,
    );
    $cats = empty($atts['category_ids']) ? false : explode(",", $atts['category_ids']);
    if ($cats) {
        $query['tax_query'] = Array(Array(
                'taxonomy' => 'category',
                'terms' => $cats,
                'field' => 'slug'
            )
        );
    }
    ob_start();
    query_posts($query);
    if (have_posts()) {
        echo $start;
        while (have_posts()) { the_post();
            $format = get_post_format() == "" ? "standard" : get_post_format(); ?>
            <article id="post-<?php the_ID(); ?>" <?php post_class($class); ?>>
                <?php call_user_func('waves_format_' . $format, $atts); ?>
            </article><?php
        }
        echo $end;
        if ($atts['pagination'] == 'true') {
            waves_pagination();
        } elseif ($atts['pagination'] == 'infiniti') {
            waves_infinite();
        }
    }
    wp_reset_query();
    $output .= ob_get_clean();
    $output .= '</div>';
    $tw_isshortcode='false';
    return $output;
}
add_shortcode('tw_blog', 'waves_blog');



/* ================================================================================== */
/*      Standard post format
/* ================================================================================== */

function waves_format_standard($atts) {
    global $post;
    $author_email = get_the_author_meta('email');
    
    if (has_post_thumbnail($post->ID)) {
        echo '<div class="entry-thumbnail">';
            $imagelink = is_single() ? (waves_image(0, 0,true).'" rel="prettyPhoto['.$post->ID.']') : get_permalink();
            echo '<a href="'.$imagelink.'">';
                $width = $atts['layout'] == 'grid' ? 360 : 850;
                echo waves_image($width, get_metabox('image_height'));
            echo '</a>';
        echo '</div>';
    }
    
    if(is_single()) { return; }
    
    echo '<h2 class="entry-title"><a href="'.get_permalink().'">'.get_the_title().'</a></h2>';
    echo '<div class="entry-meta clearfix">';            
            echo '<span class="author"> '.__('by', 'waves').' '; the_author_posts_link(); echo '</span>';
            echo '<span class="date">'.__('on', 'waves').' '.get_the_time('j F Y').'</span>';        
            echo '<span class="categories-links">'.__('in', 'waves').' '.get_the_category_list(', ').'</span>';
            if (comments_open()) {
                echo '<span class="comment-count"> '.waves_comment_count().'</span>';
            }
    echo '</div>';
    echo '<div class="entry-content clearfix">';
                waves_blogcontent($atts);
    echo '</div>';
    if(!empty($atts['more_text'])) {
        echo '<footer class="entry-meta">';
            echo '<a href="'.get_permalink().'" class="more-link">'.$atts['more_text'].'</a>';
        echo '</footer>'; 
    }
}



/* ================================================================================== */
/*      Gallery post format
/* ================================================================================== */

function waves_format_gallery($atts) {
    global $post;
    $author_email = get_the_author_meta('email');
    $ids = get_post_meta($post->ID, 'gallery_image_ids', true);
    $height = get_post_meta($post->ID, 'format_image_height', true);
    $width = 230;
    if (!empty($ids)) {
        echo '<div class="entry-gallery clearfix">';
            foreach (explode(',', $ids) as $id) {
                if (!empty($id)) {
                    $imgurl0 = aq_resize(wp_get_attachment_url($id), $width, $height, true);
                    $imgurl = !empty($imgurl0) ? $imgurl0 : wp_get_attachment_url($id);
                    $imagelink = is_single() ? (wp_get_attachment_url($id).'" rel="prettyPhoto['.$post->ID.']') : get_permalink();
                    echo '<div class="gallery-item">';
                        echo '<a href="'.$imagelink.'"><img src="'.$imgurl.'" alt="'.get_the_title().'"></a>';
                    echo '</div>';
                }
            }
        echo '</div>';
        
        if(is_single()) { return; }
        
        echo '<h2 class="entry-title"><a href="'.get_permalink().'">'.get_the_title().'</a></h2>';
        echo '<div class="entry-meta clearfix">';            
            echo '<span class="author"> '.__('by', 'waves').' '; the_author_posts_link(); echo '</span>';
            echo '<span class="date">'.__('on', 'waves').' '.get_the_time('j F Y').'</span>';        
            echo '<span class="categories-links">'.__('in', 'waves').' '.get_the_category_list(', ').'</span>';
            if (comments_open()) {
                echo '<span class="comment-count"> '.waves_comment_count().'</span>';
            }
        echo '</div>';
        echo '<div class="entry-content clearfix">';
                    waves_blogcontent($atts);
        echo '</div>';
        if(!empty($atts['more_text'])) {
            echo '<footer class="entry-meta">';
                echo '<a href="'.get_permalink().'" class="more-link">'.$atts['more_text'].'</a>';
            echo '</footer>'; 
        }
        
    } else {
        waves_format_standard($atts);
    }
}



/* ================================================================================== */
/*      Image post format
/* ================================================================================== */

function waves_format_image($atts) {
    global $post;
    $author_email = get_the_author_meta('email');
    $ids = get_post_meta($post->ID, 'gallery_image_ids', true);
    $height = get_post_meta($post->ID, 'format_image_height', true);
    $width = $atts['layout'] == 'grid' ? 360 : 850;
    if (!empty($ids)) {
        echo '<div class="entry-image image-slide-container clearfix">';
            echo '<div class="image-slide">';
            foreach (explode(',', $ids) as $id) {
                if (!empty($id)) {
                    $imgurl0 = aq_resize(wp_get_attachment_url($id), $width, $height, true);
                    $imgurl = !empty($imgurl0) ? $imgurl0 : wp_get_attachment_url($id);
                    $imagelink = is_single() ? (wp_get_attachment_url($id).'" rel="prettyPhoto['.$post->ID.']') : get_permalink();
                    echo '<div class="image-item">';
                        echo '<a href="'.$imagelink.'"><img src="'.$imgurl.'" alt="'.get_the_title().'"></a>';
                    echo '</div>';
                }
            }
            echo '</div>';
            echo '<div class="carousel-arrow"><a class="carousel-prev" href="#"><i class="fa fa-angle-left"></i></a><a class="carousel-next" href="#"><i class="fa fa-angle-right"></i></a></div>';
            echo '<div class="image-slide-bullet"></div>';
        echo '</div>';
        
        if(is_single()) { return; }
        
        echo '<h2 class="entry-title"><a href="'.get_permalink().'">'.get_the_title().'</a></h2>';
        echo '<div class="entry-meta clearfix">';            
            echo '<span class="author"> '.__('by', 'waves').' '; the_author_posts_link(); echo '</span>';
            echo '<span class="date">'.__('on', 'waves').' '.get_the_time('j F Y').'</span>';        
            echo '<span class="categories-links">'.__('in', 'waves').' '.get_the_category_list(', ').'</span>';
            if (comments_open()) {
                echo '<span class="comment-count"> '.waves_comment_count().'</span>';
            }
        echo '</div>';
        echo '<div class="entry-content clearfix">';
                    waves_blogcontent($atts);
        echo '</div>';
        if(!empty($atts['more_text'])) {
            echo '<footer class="entry-meta">';
                echo '<a href="'.get_permalink().'" class="more-link">'.$atts['more_text'].'</a>';
            echo '</footer>'; 
        }
    
    } else {
        waves_format_standard($atts);
    }
}



/* ================================================================================== */
/*      Video post format
/* ================================================================================== */

function waves_format_video($atts) {
    global $post;
    $author_email = get_the_author_meta('email');
    $embed = get_post_meta($post->ID, 'format_video_embed', true);
    $thumb = get_post_meta($post->ID, 'format_video_thumb', true);
    $url = get_post_meta($post->ID, 'format_video_m4v', true);
    
    if(!empty($embed) || !empty($url)) {
        echo '<div class="entry-video">';
            if (!empty($embed)) {
                echo apply_filters("the_content", htmlspecialchars_decode($embed));
            } else {
                if (!empty($url)) {
                    add_action('wp_footer', 'waves_jplayer_script');
                    waves_jplayer_video($post->ID, $url, $thumb);
                }
            }
        echo '</div>';
        
        if(is_single()) { return; }
        
        echo '<h2 class="entry-title"><a href="'.get_permalink().'">'.get_the_title().'</a></h2>';
        echo '<div class="entry-meta clearfix">';            
            echo '<span class="author"> '.__('by', 'waves').' '; the_author_posts_link(); echo '</span>';
            echo '<span class="date">'.__('on', 'waves').' '.get_the_time('j F Y').'</span>';        
            echo '<span class="categories-links">'.__('in', 'waves').' '.get_the_category_list(', ').'</span>';
            if (comments_open()) {
                echo '<span class="comment-count"> '.waves_comment_count().'</span>';
            }
        echo '</div>';
        echo '<div class="entry-content clearfix">';
                    waves_blogcontent($atts);
        echo '</div>';
        if(!empty($atts['more_text'])) {
            echo '<footer class="entry-meta">';
                echo '<a href="'.get_permalink().'" class="more-link">'.$atts['more_text'].'</a>';
            echo '</footer>'; 
        }
    } else {
        waves_format_standard($atts);
    }
}



/* ================================================================================== */
/*      Audio post format
/* ================================================================================== */

function waves_format_audio($atts) {
    global $post;
    $author_email = get_the_author_meta('email');
    $url = get_post_meta($post->ID, 'format_audio_mp3', true);
    $embed = get_post_meta($post->ID, 'format_audio_embed', true);
    
    if(!empty($embed) || !empty($url)) {
        echo '<div class="entry-audio">';
            if (!empty($embed)) {
                echo apply_filters("the_content", htmlspecialchars_decode($embed));
            } else {
                the_post_thumbnail();
                if (!empty($url)) {
                    add_action('wp_footer', 'waves_jplayer_script');
                    waves_jplayer_audio($post->ID, $url);
                }
            }
        echo '</div>';
        
        if(is_single()) { return; }
        
        echo '<h2 class="entry-title"><a href="'.get_permalink().'">'.get_the_title().'</a></h2>';
        echo '<div class="entry-meta clearfix">';            
            echo '<span class="author"> '.__('by', 'waves').' '; the_author_posts_link(); echo '</span>';
            echo '<span class="date">'.__('on', 'waves').' '.get_the_time('j F Y').'</span>';        
            echo '<span class="categories-links">'.__('in', 'waves').' '.get_the_category_list(', ').'</span>';
            if (comments_open()) {
                echo '<span class="comment-count"> '.waves_comment_count().'</span>';
            }
        echo '</div>';
        echo '<div class="entry-content clearfix">';
                    waves_blogcontent($atts);
        echo '</div>';
        if(!empty($atts['more_text'])) {
            echo '<footer class="entry-meta">';
                echo '<a href="'.get_permalink().'" class="more-link">'.$atts['more_text'].'</a>';
            echo '</footer>'; 
        }
        
    } else {
        waves_format_standard($atts);
    }
}



/* ================================================================================== */
/*      Quote post format
/* ================================================================================== */

function waves_format_quote($atts) {
    global $post;

    $quote_text = get_post_meta($post->ID, 'format_quote_text', true);
    if (!empty($quote_text)) {
        echo '<blockquote>';
        echo '<div class="background"><i class="fa fa-quote-left"></i></div>';
        echo "<h2>" . $quote_text . "</h2>";
        $quote_author = get_post_meta($post->ID, 'format_quote_author', true);
        if (!empty($quote_author)) {
            echo '<span class="sub-title">' . $quote_author . '</span>';
        }
        echo "</blockquote>";
    } else {
        waves_format_standard($atts);
    }
}



/* ================================================================================== */
/*      Link post format
/* ================================================================================== */

function waves_format_link($atts) {
    global $post;

    $link_url = get_post_meta($post->ID, 'format_link_url', true);
    if(!empty($link_url)){
        echo '<div class="link-content"><div class="background"><i class="fa fa-link"></i></div>';
        echo '<h2 class="link-text"><a href="' . esc_url($link_url) . '" target="_blank">' . get_the_title() . '</a></h2>';
        echo '<a href="' . esc_url($link_url) . '" target="_blank"><span class="sub-title">' . $link_url . '</span></a></div>';
    } else {
        waves_format_standard($atts);
    }
}



/* ================================================================================== */
/*      Status post format
/* ================================================================================== */

function waves_format_status($atts) {
    global $post;

    $status_url = get_post_meta($post->ID, 'format_status_url', true);
    if (!empty($status_url)) {
        echo apply_filters("the_content", $status_url);
    } else {
        waves_format_standard($atts);
    }
}



/* ================================================================================== */
/*      Aside post format
/* ================================================================================== */

function waves_format_aside($atts) {
    waves_format_standard($atts);
}




/* ================================================================================== */
/*      Chat post format
/* ================================================================================== */

function waves_format_chat($atts) {
    waves_format_standard($atts);
}



/* ================================================================================== */
/*      jPlayer Audio
/* ================================================================================== */

function waves_jplayer_audio($id, $url) { ?>
    <div id="jquery_jplayer_<?php echo $id; ?>" class="jp-jplayer jp-jplayer-audio" data-pid="<?php echo $id; ?>" data-mp3="<?php echo $url; ?>"></div>
    <div class="jp-audio-container">
        <div class="jp-audio">
            <div class="jp-type-single">
                <div id="jp_interface_<?php echo $id; ?>" class="jp-interface">
                    <ul class="jp-controls">
                        <li><div class="seperator-first"></div></li>
                        <li><div class="seperator-second"></div></li>
                        <li><a href="#" class="jp-play" tabindex="1">play</a></li>
                        <li><a href="#" class="jp-pause" tabindex="1">pause</a></li>
                        <li><a href="#" class="jp-mute" tabindex="1">mute</a></li>
                        <li><a href="#" class="jp-unmute" tabindex="1">unmute</a></li>
                    </ul>
                    <div class="jp-progress-container">
                        <div class="jp-progress">
                            <div class="jp-seek-bar">
                                <div class="jp-play-bar"></div>
                            </div>
                        </div>
                    </div>
                    <div class="jp-volume-bar-container">
                        <div class="jp-volume-bar">
                            <div class="jp-volume-bar-value"></div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
<?php }



/* ================================================================================== */
/*      jPlayer Video
/* ================================================================================== */

function waves_jplayer_video($id, $url, $thumb) { ?>
    <div id="jquery_jplayer_<?php echo $id; ?>" class="jp-jplayer jp-jplayer-video" data-pid="<?php echo $id; ?>" data-m4v="<?php echo $url; ?>" data-thumb="<?php echo $thumb; ?>"></div>
    <div class="jp-video-container">
        <div class="jp-video">
            <div class="jp-type-single">
                <div id="jp_interface_<?php echo $id; ?>" class="jp-interface">
                    <ul class="jp-controls">
                        <li><div class="seperator-first"></div></li>
                        <li><div class="seperator-second"></div></li>
                        <li><a href="#" class="jp-play" tabindex="1">play</a></li>
                        <li><a href="#" class="jp-pause" tabindex="1">pause</a></li>
                        <li><a href="#" class="jp-mute" tabindex="1">mute</a></li>
                        <li><a href="#" class="jp-unmute" tabindex="1">unmute</a></li>
                    </ul>
                    <div class="jp-progress-container">
                        <div class="jp-progress">
                            <div class="jp-seek-bar">
                                <div class="jp-play-bar"></div>
                            </div>
                        </div>
                    </div>
                    <div class="jp-volume-bar-container">
                        <div class="jp-volume-bar">
                            <div class="jp-volume-bar-value"></div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
<?php }