<?php
/* ================================================================================== */
/*      Service Shortcode
/* ================================================================================== */
if (!function_exists('shortcode_tw_service')) {

    function shortcode_tw_service($atts, $content) {
        $atts = shortcode_atts( array(
            'size'  => 'col-md-3',
            'class' => '',
            'title' => '',
            "service_style" => "style_1",
            "thumb_type" => "fi",
            "service_thumb_width" => "20",
            "service_thumb" => "",
            "add_thumb" => "Upload",
            // Font icon
            "fi" => "",
            "fi_size" => "30",
            "fi_padding" => "20",
            "fi_color" => "#aaaaaa",
            "fi_bg_color" => "",
            "fi_border_color" => "#aaaaaa",
            "fi_rounded" => "6",
            "fi_rounded_size" => "3",
            "fi_icon" => "fa-glass",
            // Circle Chart
            "cc" => "",
            "cc_type" => "text",
            "cc_line_width" => "8",
            "cc_text" => "80%",
            "cc_percent" => "80",
            "cc_size" => "100",
            "cc_font_size" => "30",
            "cc_font_color" => "#16d1ac",
            "cc_color" => "#16d1ac",
            "cc_track_color" => "#f9f9f9",
            "cc_icon" => "fa-star",
            // -----------------------
            "service_title" => "Your Service Title",
            "more_text" => "Read More",
            "more_url" => "",
            "more_target" => "_blank",
            'animation' => 'none',
            'animation_delay' => ''
        ), $atts );
        
        $thumb = '';
        $thumbType = isset($atts['thumb_type']) ? $atts['thumb_type'] : 'fi';
        $style_for_desc = '';
        $margin_for_desc = '';
        $margin_top = $icon_top = '';
        switch($atts['service_style']) {
            case 'style_4': $class = 'style-4'; break;
            case 'style_3': $class = 'style-3'; break;
            case 'style_2': $class = 'style-2'; break;
            default: $class = 'style-1'; break;
        }
        if ($class === 'style-2' || $class === 'style-3') {
            $class .= ' left-service';
            $style_for_desc = 'desc_unstyle';
            $margin_for_desc = 'margin-left:' . ($thumbType === 'fi' ? ($atts['fi_size'] + $atts['fi_padding'] + $atts['fi_padding'] + ($atts['fi_rounded'] * 2) + 20) : ($thumbType === 'image' ? (intval($atts['service_thumb_width']) + 30) : (intval($atts['cc_size']) + 15))) . 'px;';
        } elseif($class === 'style-4') {
            $iconheight = ($thumbType === 'fi' ? (($atts['fi_size'] + $atts['fi_padding'] + $atts['fi_padding'] + ($atts['fi_rounded'] * 2))/2) : ($thumbType === 'image' ? (intval($atts['service_thumb_width'])/2) : (intval($atts['cc_size'])/2)));
            $margin_top = 'margin-top:'  . $iconheight . 'px;';
            $icon_top = ' style="margin-top:-'  . $iconheight . 'px;"';
        }
        if ($thumbType === 'image') {
            $thumb = isset($atts['service_thumb']) ? '<img title="' . $atts['service_title'] . '" width="' . $atts['service_thumb_width'] . '" src="' . $atts['service_thumb'] . '" />' : '';
        } elseif ($thumbType === 'fi') {
            $thumb = do_shortcode('[tw_fonticon size="waves-shortcode" fi_size="' . $atts['fi_size'] . '" fi_padding="' . $atts['fi_padding'] . '" fi_color="' . $atts['fi_color'] . '" fi_bg_color="' . $atts['fi_bg_color'] . '" fi_border_color="' . $atts['fi_border_color'] . '" fi_rounded="' . $atts['fi_rounded'] . '" fi_rounded_size="' . $atts['fi_rounded_size'] . '" fi_icon="' . $atts['fi_icon'] . '"]');
        } elseif ($thumbType === 'cc') {
            $thumb = do_shortcode('[tw_chart_circle size="waves-shortcode" cc_type="' . $atts['cc_type'] . '" cc_line_width="' . $atts['cc_line_width'] . '" cc_text="' . $atts['cc_text'] . '" cc_percent="' . $atts['cc_percent'] . '" cc_size="' . $atts['cc_size'] . '" cc_font_size="' . $atts['cc_font_size'] . '" cc_font_color="' . $atts['cc_font_color'] . '" cc_color="' . $atts['cc_color'] . '" cc_track_color="' . $atts['cc_track_color'] . '" cc_icon="' . $atts['cc_icon'] . '"]');
        }
        $output  = waves_item($atts,'','style="'.$margin_top.'"');
        $output .= '<div class="tw-service-box '.$class.'">';
        $output .= '<div class="tw-service-icon"'.$icon_top.'>' . $thumb . '</div>';
        $output .= '<div class="tw-service-content ' . $style_for_desc . '"' . ($atts['service_style'] === 'style_2' ? (' style="' . $margin_for_desc . '"') : '') . '>';
        $output .= '<h3' . ($atts['service_style'] === 'style_3' ? (' style="' . $margin_for_desc . '"') : '') . '>' . $atts['service_title'] . '</h3>';
        if($class === 'style-4') { $output .= '<div class="service-title-sep"></div>'; }
        $output .= $atts['service_style'] === 'style_3' ? ('<div class="clearfix"></div>') : '';
        if (do_shortcode($content) != '')
            $output .= '<p>' . do_shortcode($content) . '</p>';
        if (!empty($atts['more_url']))
            $output .= '<a href="' . $atts['more_url'] . '" target="' . $atts['more_target'] . '">' . $atts['more_text'] . '</a>';
        $output .= '</div>';
        $output .= "</div>";
        $output .= "</div>";
        return $output;
    }

}
add_shortcode('tw_service', 'shortcode_tw_service');