<?php

require_once ( THEME_PATH . '/framework/post-options.php');

function metabox_render($post, $metabox) {
        $options = get_post_meta($post->ID, 'themewaves_'.strtolower(THEMENAME).'_options', true);?>
        <input type="hidden" name="themewaves_meta_box_nonce" value="<?php echo wp_create_nonce(basename(__FILE__));?>" />
        <table class="form-table tw-metaboxes">
            <tbody>
                    <?php	                              
                    foreach ($metabox['args'] as $settings) {
                        $settings['value'] = isset($options[$settings['id']]) ? $options[$settings['id']] : (isset($settings['std']) ? $settings['std'] : '');
                        call_user_func('settings_'.$settings['type'], $settings);	
                    }
                    ?>
            </tbody>
        </table>
<?php 
}



add_action('save_post', 'savePostMeta');
function savePostMeta($post_id) {
    global $tw_post_settings, $tw_page_settings, $tw_comingsoon_settings, $tw_onepage_settings, $tw_portfolio, $tw_portfolio_gallery, $tw_portfolio_video, $tw_slider_settings;

    $meta = 'themewaves_'.strtolower(THEMENAME).'_options';
    
    // verify nonce
    if (!isset($_POST['themewaves_meta_box_nonce']) || !wp_verify_nonce($_POST['themewaves_meta_box_nonce'], basename(__FILE__))) {
            return $post_id;
    }
    
    // check autosave
    if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
        return $post_id;
    }
    
    if($_POST['post_type']=='post')
        $metaboxes = $tw_post_settings;
    elseif($_POST['post_type']=='page')
        $metaboxes = array_merge($tw_page_settings,$tw_onepage_settings,$tw_comingsoon_settings);
    elseif($_POST['post_type']=='portfolio') {
        $metaboxes = array_merge($tw_portfolio,$tw_portfolio_gallery,$tw_portfolio_video);
        if(!get_post_meta($post_id, 'post_likeit', true))
            update_post_meta($post_id, 'post_likeit', 0);
    }
    elseif($_POST['post_type']=='slider')
        $metaboxes = $tw_slider_settings;
    
    if(!empty($metaboxes)) {
        $myMeta = array();

        foreach ($metaboxes as $metabox) {
            $myMeta[$metabox['id']] = isset($_POST[$metabox['id']]) ? $_POST[$metabox['id']] : "";
        }

        update_post_meta($post_id, $meta, $myMeta);        

    }
}



/* ================================================================================== */
/*      Save gallery images
/* ================================================================================== */

function themewaves_save_images() {

	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) { return; }
	
        if ( !isset($_POST['ids']) || !isset($_POST['nonce']) || !wp_verify_nonce( $_POST['nonce'], 'themewaves-ajax' ) ) { return; }
        
        if ( !current_user_can( 'edit_posts' ) ) { return; }
 
	$ids = strip_tags(rtrim($_POST['ids'], ','));
	update_post_meta($_POST['post_id'], 'gallery_image_ids', $ids);

	// update thumbs
	$thumbs = explode(',', $ids);
	$gallery_thumbs = '';
	foreach( $thumbs as $thumb ) {
		$gallery_thumbs .= '<li>' . wp_get_attachment_image( $thumb, array(32,32) ) . '</li>';
	}

	echo $gallery_thumbs;

	die();
}
add_action('wp_ajax_themewaves_save_images', 'themewaves_save_images');
?>