<?php

function theme_option_styles() {

    function hex2rgb($hex) {
        $hex = str_replace("#", "", $hex);

        if (strlen($hex) == 3) {
            $r = hexdec(substr($hex, 0, 1) . substr($hex, 0, 1));
            $g = hexdec(substr($hex, 1, 1) . substr($hex, 1, 1));
            $b = hexdec(substr($hex, 2, 1) . substr($hex, 2, 1));
        } else {
            $r = hexdec(substr($hex, 0, 2));
            $g = hexdec(substr($hex, 2, 2));
            $b = hexdec(substr($hex, 4, 2));
        }
        $rgb = array($r, $g, $b);
        return implode(",", $rgb); // returns the rgb values separated by commas
        //return $rgb; // returns an array with the rgb values
    }
    ?>

    <!-- Custom CSS -->

    <style>
        body {
            font-family: <?php echo tw_option('body_text_font', 'face'); ?>, Arial, Helvetica, sans-serif;
            font-size: <?php echo tw_option('body_text_font', 'size'); ?>; 
            font-weight: <?php echo tw_option('body_text_font', 'style'); ?>; 
            color: <?php echo tw_option('body_text_font', 'color'); ?>;
            <?php
            $boxed=false;
            if(tw_option('theme_layout') == 'boxed'){
                $boxed=true;
            }
            if( is_page() && get_metabox('theme_layout') == 'fullwidth'){
                $boxed=false;
            }
            
            if ($boxed) {
                if (tw_option('background_color') != "") {
                    echo 'background-color: ' . tw_option('background_color') . ';';
                }
                if (tw_option('background_image') != "") {
                    echo 'background-image: url(' . tw_option('background_image') . ');';
                    if (tw_option('background_repeat') != 'stretch') {
                        echo 'background-repeat: ' . tw_option('background_repeat') . ';';
                    } else {
                        echo '-webkit-background-size: cover; -moz-background-size: cover; -o-background-size: cover; background-size: cover;';
                    }
                }
                echo "background-attachment: fixed;";
                echo "margin-top:" . tw_option('margin_top') . "px;";
                echo "margin-bottom:" . tw_option('margin_bottom') . "px";
            }
            ?>
        }
        
        #sidebar a{
            font-family: <?php echo tw_option('body_text_font', 'face'); ?>, Arial, Helvetica, sans-serif;
        }
        h1,h2,h3,h4,h5,h6,
        input[type="password"],
        input[type="submit"],
        input[type="reset"],
        input[type="button"]
        button,
        article .more-link,
        .tw_post_sharebox span,
        .btn,
        .accordion-heading .accordion-toggle,
        .waves-heading .heading-title,
        .tw-breadcrumb,
        .pricing-top>span:first-child,
        .process-title,
        .process-number,
        .nav-tabs>li span,
        .portfolio-overlay .portfolio-meta,
        .portfolio-filter li a,
        .waves-pagination ul.page-numbers{font-family: <?php echo tw_option('heading_font'); ?>;}
        h1{ font-size: <?php echo tw_option('h1_spec_font', 'size'); ?>; color: <?php echo tw_option('h1_spec_font', 'color'); ?>; }
        h2{ font-size: <?php echo tw_option('h2_spec_font', 'size'); ?>; color: <?php echo tw_option('h2_spec_font', 'color'); ?>; }
        h3{ font-size: <?php echo tw_option('h3_spec_font', 'size'); ?>; color: <?php echo tw_option('h3_spec_font', 'color'); ?>; }
        h4{ font-size: <?php echo tw_option('h4_spec_font', 'size'); ?>; color: <?php echo tw_option('h4_spec_font', 'color'); ?>; }
        h5{ font-size: <?php echo tw_option('h5_spec_font', 'size'); ?>; color: <?php echo tw_option('h5_spec_font', 'color'); ?>; }
        h6{ font-size: <?php echo tw_option('h6_spec_font', 'size'); ?>; color: <?php echo tw_option('h6_spec_font', 'color'); ?>; }


        /* Header ------------------------------------------------------------------------ */  
        #header, .header-clone, .theme-boxed #header { background-color: <?php echo tw_option('header_background'); ?>; }
        #header.header-small { background-color: <?php echo "rgba(" . hex2rgb(tw_option('header_background')) . ",.98)" ?>;}
        /* Page Title ------------------------------------------------------------------------ */  
        #page-title { background-color: <?php echo tw_option('page_title_background'); ?>; }

        /* Body BG color ------------------------------------------------------------------------ */  
        #main { background: <?php echo tw_option('body_background'); ?>; }

        .tw-logo { height: <?php echo tw_option('header_height'); ?>px;}
        .tw-logo img { line-height: <?php echo tw_option('header_height'); ?>px; max-height: <?php echo tw_option('header_height') - 30; ?>px;}

        /* Menu CSS ------------------------------------------------------------------------ */
        .sf-menu .waves-mega-menu .mega-menu-title { font-family: <?php echo tw_option('menu_font', 'face'); ?>, Arial, Helvetica, sans-serif;}
        ul.sf-menu > li a{ font-family: <?php echo tw_option('menu_font', 'face'); ?>, Arial, Helvetica, sans-serif; font-size: <?php echo tw_option('menu_font', 'size'); ?>; font-weight: <?php echo tw_option('menu_font', 'style'); ?>; color: <?php echo tw_option('menu_font', 'color'); ?>; }
        ul.sf-menu > li.current-menu-item,ul.sf-menu > li.current_page_item{ background-color: <?php echo tw_option('menu_hover_background'); ?>; }

        ul.sf-menu li ul { background-color: <?php echo "rgba(" . hex2rgb(tw_option('submenu_bg')) . ",.95)" ?>;}
        ul.sf-menu ul { border-color: <?php echo tw_option('menu_hover'); ?>;}
        ul.sf-menu li ul li.current-menu-item a,ul.sf-menu li ul li a{ color: <?php echo tw_option('submenu_link'); ?>; }
        ul.sf-menu li ul li.current_page_item a{ color: <?php echo tw_option('menu_hover'); ?>; }
        ul.sf-menu > li.current_page_item > a, .sf-menu > li.current_page_ancestor >a, .sf-menu > li.current-menu-ancestor >a, .sf-menu > li.current-menu-item > a{ color: <?php echo tw_option('menu_hover'); ?>;border-color: <?php echo tw_option('menu_hover'); ?>; }
        ul.sf-menu > li:hover > a, ul.sf-menu > li:hover:after{ color: <?php echo tw_option('menu_hover'); ?>; }

        .page-template-page-onepage-php .sf-menu > .tw-menu-active > a,
        .sf-menu .menu-item-has-children a:hover,
        .sf-menu > li.current_page_item.menu-item-has-children,
        .sf-menu > li.current_page_ancestor.menu-item-has-children,
        .sf-menu > li.current-menu-ancestor.menu-item-has-children,
        .sf-menu > li.current-menu-item.menu-item-has-children,
        .sf-menu .waves-mega-menu .mega-menu-title{ color: <?php echo tw_option('menu_hover'); ?>; }

        ul.sf-menu > li> a { padding-top: <?php echo (tw_option('header_height') - tw_option('menu_font', 'size')) / 2; ?>px}
        ul.sf-menu > li> a { padding-bottom: <?php echo (tw_option('header_height') - tw_option('menu_font', 'size')) / 2; ?>px}

        .sf-menu ul [class^="fa-"]:hover:before, .sf-menu ul [class*=" fa-"]:hover:before,
        .sf-menu ul .current_page_item[class^="fa-"]:before, .sf-menu ul .current_page_item[class*=" fa-"]:before
        { color: <?php echo tw_option('menu_hover'); ?>; }

        /* Pagebuilder Title ----------------------------------------------------- */
        .waves-title h3{font-family: <?php echo tw_option('element_title', 'face'); ?>, Arial, Helvetica, sans-serif; font-size: <?php echo tw_option('element_title', 'size'); ?>; font-weight: <?php echo tw_option('element_title', 'style'); ?>; color: <?php echo tw_option('element_title', 'color'); ?>; }
        /* Sidebar Widget Title ----------------------------------------------------- */ 
        h3.widget-title{font-family: <?php echo tw_option('sidebar_widgets_title', 'face'); ?>, Arial, Helvetica, sans-serif; font-size: <?php echo tw_option('sidebar_widgets_title', 'size'); ?>; font-weight: <?php echo tw_option('sidebar_widgets_title', 'style'); ?>; color: <?php echo tw_option('sidebar_widgets_title', 'color'); ?>; }
        #sidebar a{color: <?php echo tw_option('body_text_font', 'color'); ?>;}
        #sidebar a:hover{color: <?php echo tw_option('primary_color'); ?>;}
        /* Footer Widget Title ----------------------------------------------------- */ 
        #bottom h3.widget-title{font-family: <?php echo tw_option('footer_widgets_title', 'face'); ?>, Arial, Helvetica, sans-serif; font-size: <?php echo tw_option('footer_widgets_title', 'size'); ?>; font-weight: <?php echo tw_option('footer_widgets_title', 'style'); ?>; color: <?php echo tw_option('footer_widgets_title', 'color'); ?>; }


        /* Footer ------------------------------------------------------------------------ */  
        #bottom, #bottom h3.widget-title { background-color: <?php echo tw_option('footer_background'); ?>; }
        #bottom p{ color: <?php echo tw_option('footer_text_color'); ?>; }
        #bottom a:hover,#footer a:hover{ color: <?php echo tw_option('primary_color'); ?>; }

        /* General Color ------------------------------------------------------------------------ */ 

        ::selection{ background: <?php echo tw_option('primary_color'); ?>; }
        ::-moz-selection{ background: <?php echo tw_option('primary_color'); ?>; }

        /* Primary Color Changes */
        button,
        input[type="submit"],
        input[type="reset"],
        input[type="button"],

        .portfolio-filter li a.selected, .portfolio-filter li a.selected:hover,
        article .background, .tw-author, .testimonial-thumb, .pricing-footer a,
        .nav-tabs>li.active,
        .active .accordion-heading .accordion-toggle, #sidebar .tagcloud a:hover,#footer .tagcloud a:hover,      
        .waves-pagination ul.page-numbers li span.current, 
        .twitter-follow a:hover, .tw-infinite-scroll a,
        .tw-coming-soon .days,
        .tw-coming-soon .hours,
        .tw-coming-soon .minutes,
        .tw-coming-soon .seconds
        {background-color: <?php echo tw_option('primary_color'); ?>; }

        .portfolio-filter li:hover a, .pricing-top h5, h3.error404 span, .tw-service-content a:before, 
        ul.jtwt li:before, .tw-infinite-scroll a:hover, .nav-tabs>li:hover span,.nav-tabs>li:hover i,
        .accordion-heading .accordion-toggle:hover, .tw-service-box.style-4 .tw-service-content > a:hover,
        .entry-title a:hover,div.entry-meta > span a:hover,h3.carousel-title a:hover, 
        .carousel-arrow a.carousel-prev:hover, .carousel-arrow a.carousel-next:hover, 
        .testimonial-author a:hover, .nextprev-postlink .post-link-title a:hover, .carousel-meta a:hover, 
        .waves-carousel-portfolio .portfolio-meta a:hover, .waves-portfolio .portfolio-meta a:hover,
        .tw-coming-soon>.sep,#sidebar aside.widget ul li.current-menu-item a,#sidebar aside.widget ul li.current-menu-item:before, 
        .waves-pagination ul.page-numbers li a:hover, .waves-portfolio h2.portfolio-title a:hover,a:hover
        {color: <?php echo tw_option('primary_color'); ?>; }
        
        a,.comment-reply-link,.comment-respond a
        {color: <?php echo tw_option('primary_color'); ?>; }

        .portfolio-filter li a.selected, .portfolio-filter li a.selected:hover,
        .nav-tabs>li.active,
        #sidebar .tagcloud a:hover,#footer .tagcloud a:hover, .tw-dropcap.dropcap_border, .twitter-follow a:hover
        {border-color: <?php echo tw_option('primary_color'); ?>; }

        .pricing-footer a:after { border-top-color: <?php echo tw_option('primary_color'); ?>;}

        .image-overlay{background-color: <?php echo "rgba(" . hex2rgb(tw_option('primary_color')) . ",.9)" ?> ; }
        .flickr-channel a:before, .dribbble-widget a:before, .tw-recent-portfolios-widget a:before{background-color: <?php echo "rgba(" . hex2rgb(tw_option('primary_color')) . ",.9)" ?> ; }


        #footer{ background-color: <?php echo tw_option('cr_background'); ?>; }

        <?php if (woocommerce_enabled()) { ?>
            .woocommerce ul.products li.product .price ins, .woocommerce-page ul.products li.product .price ins,
            .woocommerce .quantity .plus:hover, .woocommerce-page .quantity .plus:hover, .woocommerce #content .quantity .plus:hover,
            .woocommerce-page #content .quantity .plus:hover, .woocommerce .quantity .minus:hover,
            .woocommerce-page .quantity .minus:hover, .woocommerce #content .quantity .minus:hover,
            .woocommerce-page #content .quantity .minus:hover, .woocommerce .star-rating, .woocommerce-page .star-rating, 
            ul.cart_list li > a:hover, .woocommerce-page #sidebar ul.cart_list li > a:hover, ul.product_list_widget li > a:hover, 
            .woocommerce-page #sidebar ul.product_list_widget li > a:hover, .tw-product-ordering ul > li > span span, 
            .woocommerce div.product span.price, .woocommerce-page div.product span.price, .woocommerce #content div.product span.price,
            .woocommerce-page #content div.product span.price, .woocommerce div.product p.price, .woocommerce-page div.product p.price,
            .woocommerce #content div.product p.price, .woocommerce-page #content div.product p.price, 
            .woocommerce ul.products li.product h3:hover, .woocommerce-page ul.products li.product h3:hover,
            .tw-product-ordering ul > li > a:hover
            {color: <?php echo tw_option('primary_color'); ?>; }

            .woocommerce .widget_price_filter .price_slider_amount .button, .woocommerce-page .widget_price_filter .price_slider_amount .button,
            .tw_cart_buttons a.button, #sidebar .widget_shopping_cart_content a.button, .buttons a.button,
            .woocommerce #respond input#submit, .woocommerce-page #respond input#submit
            {background-color: <?php echo tw_option('primary_color'); ?>; }

            .woocommerce .widget_price_filter .ui-slider .ui-slider-handle, .woocommerce-page .widget_price_filter .ui-slider .ui-slider-handle
            {border-color: <?php echo tw_option('primary_color'); ?>; }

            .woocommerce div.product .woocommerce-tabs ul.tabs li.active,
            .woocommerce-page div.product .woocommerce-tabs ul.tabs li.active,
            .woocommerce #content div.product .woocommerce-tabs ul.tabs li.active,
            .woocommerce-page #content div.product .woocommerce-tabs ul.tabs li.active                
            {border-top-color: <?php echo tw_option('primary_color'); ?>; }

            .thumbnail_container .product-hover-overlay{background-color: <?php echo "rgba(" . hex2rgb(tw_option('primary_color')) . ",.9)" ?> ; }
            <?php
        }
        if (is_page() && get_metabox("theme_layout") == "boxed") {
            global $post;
            echo 'body.page-id-' . $post->ID . ' {';
            if (get_metabox('bg_color') != "") {
                echo 'background-color: ' . get_metabox('bg_color') . ';';
            }
            if (get_metabox('bg_image') != "") {
                echo 'background-image: url(' . get_metabox('bg_image') . ');';
                if (get_metabox('bg_image_repeat') != 'stretch') {
                    echo 'background-repeat: ' . get_metabox('bg_image_repeat') . ';';
                } else {
                    echo '-webkit-background-size: cover; -moz-background-size: cover; -o-background-size: cover; background-size: cover;';
                }
            }
            if (get_metabox('margin_top_bottom') != "") {
                echo "margin-top:" . get_metabox('margin_top_bottom') . "px;";
                echo "margin-bottom:" . get_metabox('margin_top_bottom') . "px";
            }
            echo '}';
        }
        ?>

        <?php echo tw_option('custom_css'); ?>
    </style>

    <?php
}

add_action('wp_head', 'theme_option_styles', 100);
?>