<!DOCTYPE html>
<!--[if IE 7 ]>    <html class="ie7"> <![endif]-->
<!--[if IE 8 ]>    <html class="ie8"> <![endif]-->
<html <?php language_attributes(); ?>>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
        <!-- Mobile Specific Metas
        ================================================== -->
        <?php if(tw_option('responsive')!=='0') {
        echo '<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">';
        } ?>
        <?php favicon(); ?>
        <!--[if lt IE 9]><script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script><![endif]-->
        <?php
        facebookOpenGraphMeta();
        global $tw_end;
        $tw_start = $tw_end = '';
        $menu_fixed = (tw_option('menu_fixed') && (tw_option('responsive')!=='0')) ? ' menu-fixed' : '';
        
        $boxed = false;
        if(get_metabox("theme_layout")=="boxed") {
            $boxed = true;
        } else if(get_metabox("theme_layout")!="fullwidth") {
            if(tw_option("theme_layout")=="boxed") {
                $boxed = true;
            }
        }
        
        if ($boxed) {
            $tw_start = '<div id="theme-layout" class="theme-boxed '.$menu_fixed.'">';
            $tw_end = '</div>';
        } else {
            $tw_start = '<div id="theme-layout" class="theme-full '.$menu_fixed.'">';
            $tw_end = '</div>';
        }
        ?>
        <?php wp_head(); ?>
    </head>
    <body <?php if (is_page_template('page-onepage.php')) {echo ' id="one-page-home" ';} body_class('loading'); ?>>
        <?php echo $tw_start;
        
            $topbar = false;
            if(get_metabox("top_bar")=="true") {
                $topbar = true;
            } else if(get_metabox("top_bar")!="false") {
                if(tw_option("top_bar")) {
                    $topbar = true;
                }
            }
            if($topbar) { ?>
                <div class="tw-top-bar">
                    <div class="container">
                        <div class="row">
                            <div class="col-md-6">
                                <?php dynamic_sidebar("top-widget-left"); ?>
                            </div>
                            <div class="col-md-6">
                                <?php if (!dynamic_sidebar('top-widget-right')) : ?>
                                    <div class="tw-top-widget right"><div class="textwidget">Insert your widgets from Appearance->Widget</div></div>
                                <?php endif; ?>
                            </div>
                        </div>
                    </div>
                </div>
            <?php } ?>
        
        <!-- Start Header -->
        <header id="header" class="header-large">
            <div class="container">
                <div class="show-mobile-menu clearfix">
                    <a href="#mobile-menu" class="mobile-menu-icon">
                        <span></span><span></span><span></span><span></span>
                    </a>
                </div>
                <div class="row header">
                    <div class="col-md-3">
                        <?php theme_logo(); ?>
                    </div>
                    <div class="col-md-9">
                        <nav class="menu-container clearfix">
                            <div class="tw-menu-container">                                
                                <?php theme_menu();?>
                            </div>
                        </nav>
                    </div>
                </div>               
            </div>
            <?php if(tw_option('responsive')!=='0') {
                echo '<nav id="mobile-menu" class=" mm-is-menu">';
                        mobile_menu();
                echo '</nav>';
            } ?>
        </header>
        <?php 
        if(tw_option('menu_fixed') && (tw_option('responsive')!=='0')) {
            echo '<div class="header-clone"></div>';
        }
        ?>
        <!-- End Header -->
        <?php
            get_template_part('slider');
        ?>
        <!-- Start Loading -->
        <section id="loading"></section>
        <!-- End   Loading -->
        <!-- Start Main -->
        <section id="main">
            <div <?php echo is_page() ? 'id="page"' : 'class="container"'; ?>>