<?php
/* ================================================================================== */
/*      Portfolio Shortcode
/* ================================================================================== */

if (!function_exists('shortcode_tw_portfolio')) {

    function shortcode_tw_portfolio($atts, $content) {
        $atts = shortcode_atts(array(
            'size'  => 'col-md-12',
            'class' => '',
            'title' => '',
            'layout_size' => 'col-md-12',
            'pagination' => 'simple',
            'height' => '',
            'column' => '3',
            'count' => 9,
            'filter' => 'false',
            'category_ids' => '',
            'layout' => 'style1',
            'order' => 'date_desc',
            'not_in' => '',
//            'single' => 'ajax',
        ), $atts);
        global $paged;

        if (get_query_var('paged'))
            $my_page = get_query_var('paged');
        else {
            if (get_query_var('page'))
                $my_page = get_query_var('page');
            else
                $my_page = 1;
            set_query_var('paged', $my_page);
        }
        add_action('wp_footer', 'waves_portfolio_script');
        $query = Array(
            'post_type' => 'portfolio',
            'posts_per_page' => $atts['count'],
        );
        if(!empty($atts['not_in'])) {
            $query['post__not_in'] = array($atts['not_in']);
        }
        if ($atts['pagination'] == "simple" || $atts['pagination'] == "infinite") {
            $query['paged'] = $my_page;
        }
        $cats = empty($atts['category_ids']) ? false : explode(",", $atts['category_ids']);
        if ($cats) {
            $query['tax_query'] = Array(Array(
                    'taxonomy' => 'portfolio_cat',
                    'terms' => $cats,
                    'field' => 'slug'
                )
            );
        }
        if ($atts['order']!='date_desc') {
            switch ($atts['order']) {
                case "date_asc":
                    $query['orderby'] = 'date';
                    $query['order'] = 'ASC';                    
                    break;
                case "title_asc":
                    $query['orderby'] = 'title';
                    $query['order'] = 'ASC';                    
                    break;
                case "title_desc":
                    $query['orderby'] = 'title';
                    $query['order'] = 'DESC';
                    break;
                case "random":
                    $query['orderby'] = 'rand';
                    break;
            }
        }
        $output = waves_item($atts,'waves-portfolio '.$atts['layout']);
//            if($atts['single']==='ajax'){
//                $output .= '<div class="portfolio-single-ajax waves-full-element"><div class="container"></div></div>';
//            }
            if ($atts['filter'] == 'true') {
                $output .= '<div class="portfolio-filter">';
                    $output .= '<ul class="filters clearfix" data-option-key="filter">';
                        $output .= '<li><a href="#filter" data-option-value="*" class="selected">' . __('Show All', 'themewaves') . '</a></li>';
                        if ($cats) {
                            $filters = $cats;
                        } else {
                            $filters = get_terms('portfolio_cat');
                        }
                        foreach ($filters as $category) {
                            if ($cats) {
                                $category = get_term_by('slug', $category, 'portfolio_cat');
                            }
                            $output .= '<li class="hidden"><a href="#filter" data-option-value=".category-' . $category->slug . '" title="' . $category->name . '">' . $category->name . '</a></li>';
                        }
                    $output .= '</ul>';
                $output .= '</div>';
            }
            if(!is_tax())
            query_posts($query);
                $output .= '<div class="row">';
                    $output .= '<div class="isotope-container">';
                        while (have_posts()){ the_post();
                            $output .= call_user_func('waves_portfolio_loop', $atts);
                        }
                    $output .= '</div>';
                $output .= '</div>';
                ob_start();
                    if($atts['pagination']=="simple"){
                        waves_pagination();
                    }elseif($atts['pagination']=="infinite"){
                        waves_infinite();
                    }
                $output .= ob_get_clean();
            wp_reset_query();
        $output .= '</div>';
        return $output;
    }

}

function waves_portfolio_script() {
    wp_enqueue_script('waves-isotope', THEME_DIR . '/assets/js/jquery.isotope.min.js', false, false, true);
}

add_shortcode('tw_portfolio', 'shortcode_tw_portfolio');







function waves_portfolio_loop($atts) {
    global $post;
    
    $class = $atts['column']=='4' ? 'col-md-3' : 'col-md-4';
    $width = $atts['column']=='4' ? 270 : 370;
    
    
    $image = waves_image($width, $atts['height'], true);
    
    if($image) {    
        $cats = wp_get_post_terms($post->ID, 'portfolio_cat');
        foreach ($cats as $catalog) {
            $class .= " category-" . $catalog->slug;
        }
        $output = '<article class="portfolio '.$class.'">';
            $output .= '<div class="portfolio-block">';
                $output .= '<div class="portfolio-thumb overlay-container">';
                    $output .= '<img src="'.$image.'">';
                    $output .= '<div class="image-overlay">';
                        $output .= '<div class="portfolio-overlay-icon"><a href="'.get_permalink().'" class="plus-icon"></a></div>';
                    $output .= '</div>';
                $output .= '</div>';
                $output .= '<div class="portfolio-content">';
                    $output .= '<h2 class="portfolio-title"><a href="'.get_permalink().'">'.get_the_title().'</a></h2>';
                    $output .= get_the_term_list($post->ID, 'portfolio_cat', '<span class="portfolio-meta">', ' / ', '</span>');
                        $hide_favorites = isset($atts['hide_favorites']) ? $atts['hide_favorites'] : 'false';
                        if($hide_favorites==='false'){
                           $output .= waves_like();
                        }
                $output .= '</div>';    
            $output .= '</div>';    
        $output .= '</article>';

        return $output;
    }
}

function waves_infinite() {
    global $wp_query;
    $pages = intval($wp_query->max_num_pages);
    $paged = (get_query_var('paged')) ? intval(get_query_var('paged')) : 1;
    if (empty($pages)) {
        $pages = 1;
    }
    if (1 != $pages) {
        echo '<div class="tw-pagination tw-infinite-scroll align-center" data-has-next="' . ($paged === $pages ? 'false' : 'true') . '">';
        echo '<a class="no-more" href="#">+</a>';
        echo '<a class="loading" href="#"><i class="fa fa-cog fa-spin"></i></a>';
        echo '<a class="next" href="' . get_pagenum_link($paged + 1) . '">+</a>';
        echo '</div>';
    }
}