<?php
/* ================================================================================== */
/*      Pricing Table Shortcode
/* ================================================================================== */

function waves_pricing($atts, $content) {
    global $parentAtts;
    $atts = shortcode_atts( array(
        'size'  => '',
        'class' => '',
        'title' => '',
        'symbol' => '',
        'column_count' => 'pricing-four'
    ), $atts );
    $parentAtts = $atts;
    $atts['size'] = '';
    $output  = waves_item($atts,'waves-pricing clearfix');
    $output .= do_shortcode($content);
    $output .= '</div>';
    return $output;
}
add_shortcode('tw_pricing', 'waves_pricing');





function waves_pricing_item($atts, $content) {
    global $parentAtts;
    global $tw_isshortcode;
    $tw_isshortcode='true';
    $atts = shortcode_atts( array(
		'title' => '',
		'sub_title' => '',
		'featured' => 'false',
		'price' => '',
		'time' => '',
		'buttontext' => '',
		'buttonlink' => '',
		'animation' => 'none',
		'animation_delay' => ''
    ), $atts );
    $class=$animation='';
    if($atts['featured'] == 'true') {
        $class.=' featured';
    }
    if (isMobile() && !tw_option('mobile_animation')) {
        $atts['animation'] = 'none';
    }
    if($atts['animation']!=='none'){
        $class .= ' tw-animate-gen';
        $atts['animation_delay'] = empty($atts['animation_delay']) ? '0': str_replace(' ','',$atts['animation_delay']);
        $animation .= ' data-animation="'.$atts['animation'].'" data-animation-delay="'.$atts['animation_delay'].'" data-animation-offset="90%" style="opacity:0;"';
    }
    $symbol = !empty($parentAtts['symbol']) ? $parentAtts['symbol'] : '$';
    switch($parentAtts['column_count']){
        case 'pricing-two'  :{$class.=' col-md-6';break;}
        case 'pricing-three':{$class.=' col-md-4';break;}
        case 'pricing-four' :{$class.=' col-md-3';break;}
    }
    $output = '<div class="pricing-column'.$class.'"'.$animation.'>';
        $output .= '<div class="pricing-box">';
            $output .= '<header class="pricing-header">';
                if($atts['featured'] == 'true') {
                    $output .= '<span class="featured">'. __( 'Featured', 'themewaves' ).'</span>';
                }
                $output .= '<h1>' . $atts['title'] . '</h1>';
                $output .= '<p>' . $atts['sub_title'] . '</p>';
            $output .= '</header>';
            $output .= '<div class="pricing-top">';
                $output .= '<h4><span>'.$symbol.'</span>' . $atts['price'] . '</h4>' . '<h5>' . $atts['time'] . '</h5>';
            $output .= '</div>';
            $output .= '<div class="pricing-content">';
                $output .= apply_filters('the_content', $content);
            $output .= '</div>';
            if (!empty($atts['buttontext'])) {
                $output .= '<footer class="pricing-footer">';
                $output .= '<a href="' . esc_url($atts['buttonlink']) . '" class="btn btn-flat btn-medium"><div class="arrow"></div>' . $atts['buttontext'] . '<span class="btn-shadow"></span></a>';
                $output .= '</footer>';
            }
        $output .= '</div>';
    $output .= '</div>';
    $tw_isshortcode='false';
    return $output;
}
add_shortcode('tw_pricing_item', 'waves_pricing_item');