<?php
global $tw_socials;
$tw_socials = array(
    'facebook' => array(
        'name' => 'facebook_username',
        'link' => 'http://www.facebook.com/*',
    ),
    'flickr' => array(
        'name' => 'flickr_username',
        'link' => 'http://www.flickr.com/photos/*'
    ),
    'gplus' => array(
        'name' => 'googleplus_username',
        'link' => 'https://plus.google.com/u/0/*'
    ),
    'twitter' => array(
        'name' => 'twitter_username',
        'link' => 'http://twitter.com/*',
    ),
    'instagram' => array(
        'name' => 'instagram_username',
        'link' => 'http://instagram.com/*',
    ),
    'pinterest' => array(
        'name' => 'pinterest_username',
        'link' => 'http://pinterest.com/*',
    ),
    'skype' => array(
        'name' => 'skype_username',
        'link' => 'skype:*'
    ),
    'vimeo' => array(
        'name' => 'vimeo_username',
        'link' => 'http://vimeo.com/*',
    ),
    'youtube' => array(
        'name' => 'youtube_username',
        'link' => 'http://www.youtube.com/user/*',
    ),
    'dribbble' => array(
        'name' => 'dribbble_username',
        'link' => 'http://dribbble.com/*',
    ),
    'linkedin' => array(
        'name' => 'linkedin_username',
        'link' => '*'
    ),
    'soundcloud' => array(
        'name' => 'soundcloud_username',
        'link' => '*'
    ),
    'rss' => array(
        'name' => 'rss_username',
        'link' => 'http://*/feed'
    )
);

function tw_option($index1, $index2 = false) {
    global $smof_data;
    if ($index2) {
        $output = isset($smof_data[$index1][$index2]) ? $smof_data[$index1][$index2] : false;
        return $output;
    }
    $output = isset($smof_data[$index1]) ? $smof_data[$index1] : false;
    return $output;
}

// Page, Post custom metaboxes
//=======================================================
function get_metabox($name) {
    global $post;
    if ($post) {
        $metabox = get_post_meta($post->ID, 'themewaves_' . strtolower(THEMENAME) . '_options', true);
        return isset($metabox[$name]) ? $metabox[$name] : "";
    }
    return false;
}

function set_metabox($name, $val) {
    global $post;
    if ($post) {
        $metabox = get_post_meta($post->ID, 'themewaves_' . strtolower(THEMENAME) . '_options', true);
        $metabox[$name] = $val;
        return update_post_meta($post->ID, 'themewaves_' . strtolower(THEMENAME) . '_options', $metabox);
    }
    return false;
}

// Print menu
//=======================================================
function theme_menu() {	
    $nav_menu = get_metabox('onepage_menu');
    if($nav_menu) {
        wp_nav_menu(array(
            'container' => false,
            'menu' => $nav_menu,
            'menu_id' => 'menu',
            'menu_class' => 'sf-menu',
            'fallback_cb' => 'no_main')
        );
    } else {
        wp_nav_menu(array(
            'walker' => new waves_custom_menu(),
            'container' => false,
            'menu_id' => 'menu',
            'menu_class' => 'sf-menu',
            'fallback_cb' => 'no_main',
            'theme_location' => 'main'
        ));
    }	
}

function no_main() {
    echo "<div class='tw-menu-container clearfix'><ul id='menu' class='sf-menu'>";
    wp_list_pages(array('title_li' => ''));
    echo "</ul></div>";
}

function mobile_menu() {
    $nav_menu = get_metabox('onepage_menu');
    if($nav_menu) {
        wp_nav_menu(array(
			'container' => false,
			'menu' => $nav_menu,
			'menu_id' => '',
			'menu_class' => 'clearfix',
			'fallback_cb' => 'no_mobile')
        );
    } else {
        wp_nav_menu(array(
			'container' => false,
			'menu_id' => '',
			'menu_class' => 'clearfix',
			'fallback_cb' => 'no_mobile',
			'theme_location' => 'main')
		);
    }
}

function no_mobile() {
    echo "<ul class='clearfix'>";
    wp_list_pages(array('title_li' => ''));
    echo "</ul>";
}


function no_footer() {
    //echo "<ul class='footer-menu inline'>"; wp_list_pages(array('depth'=>1,'title_li'=>'')); echo "</ul>";
}

// Print logo
//=======================================================
function theme_logo() {
    echo '<div class="tw-logo">';
    if (tw_option("theme_logo") == "") {
        echo '<h1 class="site-name">';
        echo '<a class="logo" href="' . home_url() . '">';
        bloginfo('name');
        echo '</a>';
        echo '</h1>';
    } else {
        echo '<a class="logo" href="' . home_url() . '">';
        if (tw_option("logo_retina")) {
            echo '<img class="logo-img" src="' . tw_option("theme_logo_retina") . '" style="width:' . tw_option('logo_width') . 'px" alt="' . get_bloginfo('name') . '"/>';
        } else {
            echo '<img class="logo-img" src="' . tw_option("theme_logo") . '" alt="' . get_bloginfo('name') . '"/>';
        }
        echo '</a>';        
    }
    
    echo '</div>';
    //echo '<div class="site-description">' . get_bloginfo('description') . '</div>';
}

// Get featured text
//=======================================================
function get_featuredtext() {
    global $post;

    if (is_singular()) {
        $return = $post->post_title;
        return $return;
    } elseif (is_category()) {
        $return = (tw_option('pt_category') ? tw_option('pt_category') : __("Category", "themewaves")) . " : " . single_cat_title("", false);
        return $return;
    } elseif (is_tax('cat_portfolio')) {
        $return = (tw_option('pt_portfolio') ? tw_option('pt_portfolio') : __("Portfolio", "themewaves")) . " : " . single_cat_title("", false);
        return $return;
    } elseif (is_tag()) {
        $return = (tw_option('pt_tag') ? tw_option('pt_tag') : __("Tag", "themewaves")) . " : " . single_tag_title("", false);
        return $return;
    } elseif (is_404()) {
        $return = tw_option('pt_nothing_found') ? tw_option('pt_nothing_found') : __("Nothing Found!", "themewaves");
        return $return;
    } elseif (is_author()) {
        global $author;
        $userdata = get_userdata($author);
        $return = (tw_option('pt_author') ? tw_option('pt_author') : __("Author: ", "themewaves")) . $userdata->display_name;
        return $return;
    } elseif (is_archive()) {
        if (is_day()) {
            $return = (tw_option('pt_daily_arch') ? tw_option('pt_daily_arch') : __("Daily Archives", "themewaves")) . " : " . get_the_date();
        } elseif (is_month()) {
            $return =(tw_option('pt_monthly_arch') ? tw_option('pt_monthly_arch') : __("Monthly Archives", "themewaves")) . " : " . get_the_date("F Y");
        } elseif (is_year()) {
            $return = (tw_option('pt_yearly_arch') ? tw_option('pt_yearly_arch') : __("Yearly Archives", "themewaves")) . " : " . get_the_date("Y");
        } else {
            $return = tw_option('pt_blog_arch') ? tw_option('pt_blog_arch') : __("Blog Archives", "themewaves");
        }
        return $return;
    } elseif (is_search()) {
        $return = (tw_option('pt_search_result') ? tw_option('pt_search_result') : __("Search results for", "themewaves")) . " : " . get_search_query();
        return $return;
    }
}
// Sidebar
//=======================================================
function sidebar($sidebar = 'sidebar') {
    if (function_exists('dynamic_sidebar') && dynamic_sidebar($sidebar)) {
        
    }
}

function print_styles($links) {
    for ($i = 0; $i < count($links); $i++) {
        echo '<link type="text/css" rel="stylesheet" href="' . file_require(get_template_directory_uri() . '/' . $links[$i], true) . '" />';
    }

    echo '<link type="text/css" rel="stylesheet" href="http://fonts.googleapis.com/css?family=' . str_replace(" ", "+", get_settings_value('head_felement')) . ':300,300italic,400,400italic,700,700italic,600,600italic" />';
    if (get_settings_value('body_felement') != get_settings_value('head_felement')) {
        echo '<link type="text/css" rel="stylesheet" href="http://fonts.googleapis.com/css?family=' . str_replace(" ", "+", get_settings_value('body_felement')) . ':400,400italic,700,700italic" />';
    }
}

function favicon() {
    if (tw_option('theme_favicon') == "") {
        echo '<link rel="shortcut icon" href="' . THEME_DIR . '/assets/img/favicon.ico"/>';
    } else {
        echo '<link rel="shortcut icon" href="' . tw_option('theme_favicon') . '"/>';
    }
    if (tw_option('favicon_retina')) {
        echo tw_option('favicon_iphone') != "" ? ('<link rel="apple-touch-icon" href="' . tw_option('favicon_iphone') . '"/>') : '';
        echo tw_option('favicon_iphone_retina') != "" ? ('<link rel="apple-touch-icon" sizes="114x114" href="' . tw_option('favicon_iphone_retina') . '"/>') : '';
        echo tw_option('favicon_ipad') != "" ? ('<link rel="apple-touch-icon" sizes="72x72" href="' . tw_option('favicon_ipad') . '"/>') : '';
        echo tw_option('favicon_ipad_retina') != "" ? ('<link rel="apple-touch-icon" sizes="144x144" href="' . tw_option('favicon_ipad_retina') . '"/>') : '';
    }
}


if (!function_exists('mytheme_comment')) {

    function mytheme_comment($comment, $args, $depth) {

        $GLOBALS['comment'] = $comment;
        print '<div class="comment-block">';
        ?>	
        <div class="comment" id="comment-<?php comment_ID(); ?>">
            <div class="comment-author"><span class="reply-line"></span>
                <?php echo get_avatar($comment, $size = '70'); ?>
                <div class="comment-meta">
                    <h6 class="comment-author-link">
                        <?php echo get_comment_author_link(); ?>
                    </h6>                            
                    <span class="comment-date">
                        <?php printf(__('written on %1$s - ', 'themewaves'), get_comment_date('j F Y')); ?>
                    </span>
                    <span class="comment-replay-link"><?php comment_reply_link(array_merge($args, array('depth' => $depth, 'max_depth' => $args['max_depth']))) ?></span>
                </div>
            </div>
            <div class="comment-body">
                <?php comment_text() ?>
            </div>
        </div><?php
    }

}






if (!function_exists('tw_comment_form')) {

    function tw_comment_form($fields) {
        global $id, $post_id;
        if (null === $post_id)
            $post_id = $id;
        else
            $id = $post_id;

        $commenter = wp_get_current_commenter();
        $req = get_option('require_name_email');
        $aria_req = ( $req ? " aria-required='true'" : '' );

        $fields = array(
            'author' => '<div class="row-fluid"><div class="comment-form-author"><p>' .
            '<input id="author" name="author" placeholder="'.__('Name', 'themewaves').'" type="text" value="' . esc_attr($commenter['comment_author']) . '" size="30"' . $aria_req . ' />' . '</p>',
            'email' => '<p class="comment-form-email">' .
            '<input id="email" name="email" placeholder="'.__('Email', 'themewaves').'" type="text" value="' . esc_attr($commenter['comment_author_email']) . '" size="30"' . $aria_req . ' />' . '</p>',
//            '<label for="email">' . __('Email', 'themewaves') . '</label> ' . ( $req ? '<span class="required">*</span>' : '' ) . '</p>',
            'url' => '<p class="comment-form-url">' .
            '<input id="url" name="url" placeholder="'.__('Website', 'themewaves').'" type="text" value="' . esc_attr($commenter['comment_author_url']) . '" size="30" />' .
            '</p></div></div>',
        );
        return $fields;
    }

    add_filter('comment_form_default_fields', 'tw_comment_form');
}


if (!function_exists('about_author')) {

    function about_author() {
        $tw_author = false;
        if (get_metabox("post_authorr") == "true") {
            $tw_author = true;
        } else if (get_metabox("post_authorr") != "false") {
            if (tw_option('post_author')) {
                $tw_author = true;
            }
        }
        if ($tw_author) {
            ?>
            <div class="tw-author clearfix">
                <div class="author-image"><?php
                    $tw_author_email = get_the_author_meta('email');
                    echo get_avatar($tw_author_email, $size = '70');
                    ?>
                </div>
                <h3><?php
                    _e("Written by ", "themewaves");
                    if (is_author())
                        the_author();
                    else
                        the_author_posts_link();
                    ?>
                </h3>
                <p><?php
                    $description = get_the_author_meta('description');
                    if ($description != '')
                        echo $description;
                    else
                        _e('The author didnt add any Information to his profile yet', 'themewaves');
                    ?>
                </p>
            </div><?php
        }
    }

}

function related_portfolios() {
    global $post;

    $tags = wp_get_post_terms($post->ID, 'portfolio_cat', array("fields" => "ids"));

    if ($tags) {
        $rel_title = tw_option('translate_relatedportfolio') ? tw_option('translate_relatedportfolio') : __('Related Works', 'themewaves');
        echo do_shortcode('[tw_item_title  title="' . $rel_title . '"]');
        $tag_ids = "";
        foreach ($tags as $tag) {
            $term = get_term( $tag, 'portfolio_cat' );
            $tag_ids .= $term->slug . ",";
        }            

        echo '<div class="row"><div class="related_portfolios">';
        echo do_shortcode('[tw_portfolio category_ids="'.$tag_ids.'" count="3" not_in="'.$post->ID.'" port_column_count="3" height="'.tw_option('port_height').'" pagination="none"]');
        echo '</div></div>';
    }
}

function tw_social() {
    global $tw_socials;
    foreach ($tw_socials as $key => $social) {
        if (tw_option($social['name']) != "") {
            echo '<a href="' . (str_replace('*', tw_option($social['name']), $social['link'])) . '" target="_blank" title="' . $key . '" class="' . $key . '"><span class="tw-icon-' . $key . '"></span></a>';
        }
    }
}
function tw_get_socials($socialNames=array()) {
    global $tw_socials;
    $output='';
    foreach ($tw_socials as $key => $social) {
        if (!empty($socialNames[$social['name']])) {
            $output.='<a href="' . (str_replace('*', $socialNames[$social['name']], $social['link'])) . '" target="_blank" title="' . $key . '" class="' . $key . '"><span class="tw-icon-' . $key . '"></span></a>';
        }
    }
    return $output;
}


function tw_social_share() {

    $output = '<div class="tw_post_sharebox clearfix">';

    if (tw_option('facebook_share')) {
        //$output .= '<div class="facebook_share"><iframe src="http' . (is_ssl() ? 's' : '') . '://www.facebook.com/plugins/like.php?href=' . urlencode($post_link) . '&amp;layout=button_count&amp;show_faces=false&amp;width=80&amp;action=like&amp;font=verdana&amp;colorscheme=light&amp;height=21" scrolling="no" frameborder="0" allowTransparency="true"></iframe></div>';
        $output .= '<div class="facebook-share"><a href="#" title="Share this"><i class="fa fa-facebook"></i><span class="count">'.facebook_count(get_permalink()).'</span></a></div>';
    }
    if (tw_option('googleplus_share')) {
        $output .= '<div class="googleplus-share"><a href="#" title="Share this"><i class="fa fa-google-plus"></i><span class="count">'.googleplus_count(get_permalink()).'</span></a></div>';
    }
    if (tw_option('twitter_share')) {
        $post_title = get_the_title();
        $output .= '<div class="twitter-share"><a href="#" title="Tweet" data-title="'.$post_title.'"><i class="fa fa-twitter"></i><span class="count">'.twitter_count(get_permalink()).'</span></a></div>';
    }
    if (tw_option('pinterest_share')) {
        $post_image = waves_image(0, 0, true);
        $output .= '<div class="pinterest-share"><a href="#" title="Pin It" data-image="'.$post_image.'"><i class="fa fa-pinterest"></i><span class="count">'.pinterest_count(get_permalink()).'</span></a></div>';
    }
    if (tw_option('linkedin_share')) {
        $output .= '<div class="linkedin_share"><a href="https://www.linkedin.com/cws/share?url='.get_permalink().'&title='.get_the_title().'&summary='.get_the_excerpt().'" title="Linkedin Share" data-image="'.$post_image.'"><i class="fa fa-linkedin"></i></a><script type="in/share" data-url="' . get_permalink() . '" data-counter="right"></script></div>';
    }
    $output .= '</div>';

    return $output;
}

function isMobile() {
    return(preg_match('/(alcatel|amoi|android|avantgo|blackberry|benq|cell|cricket|docomo|elaine|htc|iemobile|iphone|ipad|ipaq|ipod|j2me|java|midp|mini|mmp|mobi|motorola|nec-|nokia|palm|panasonic|philips|phone|sagem|sharp|sie-|smartphone|sony|symbian|t-mobile|telus|up\.browser|up\.link|vodafone|wap|webos|wireless|xda|xoom|zte)/i', $_SERVER['HTTP_USER_AGENT']));
}


function twitter_count($url)
{
        return 0;
        try {
            $contents = file_get_contents('http://urls.api.twitter.com/1/urls/count.json?url=' . $url);
        } catch(Exception $e) {
            return 0;
        }
        if($contents) {
                return json_decode($contents)->count;
        } else {
                return 0;
        }
}

function facebook_count($url)
{
        return 0;
        try {
            $contents = file_get_contents("http://graph.facebook.com/fql?q=SELECT%20url,%20total_count%20FROM%20link_stat%20WHERE%20url='".$url."'");
        } catch(Exception $e) {
            return 0;
        }
        if($contents) {
                $json = json_decode($contents);
                return isset($json->data[0]->total_count) ? $json->data[0]->total_count : 0;
        } else {
                return 0;
        }
}

function googleplus_count($url)
{
        return 0;
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, "https://clients6.google.com/rpc?key=".tw_option('googleplus_api'));
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS, '[{"method":"pos.plusones.get","id":"p",
        "params":{"nolog":true,"id":"' . $url . '","source":"widget","userId":"@viewer","groupId":"@self"},
        "jsonrpc":"2.0","key":"p","apiVersion":"v1"}]');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-type: application/json'));
        $curl_results = curl_exec ($ch);
        curl_close ($ch);
        
        if($curl_results) {
                $json = json_decode($curl_results, true);
                if(!isset($json[0]['error'])) {
                        return $json[0]['result']['metadata']['globalCounts']['count'];
                } else {
                        return 0;
                }
        } else {
                return 0;
        }
}

function pinterest_count($url)
{
        return 0;
        $contents = file_get_contents('http://api.pinterest.com/v1/urls/count.json?callback=&url=' . $url);
        if($contents) {
                $contents = preg_replace('/.+?({.+}).+/','$1', $contents);

                $json = json_decode($contents);
                return $json->count !== '-' ? $json->count : 0;
        } else {
                return 0;
        }
}


// jPlayer

function waves_jplayer_script() {
    wp_enqueue_script('waves_jplayer_script', THEME_DIR.'/assets/js/jquery.jplayer.min.js', false, false, true);
}


// Post Image Show

function waves_image($width = 0, $height = "", $returnURL=false) {
    global $post;
    $attachment = get_post(get_post_thumbnail_id($post->ID));
    if (!empty($attachment)) {
        $alt0 = get_post_meta($attachment->ID, '_wp_attachment_image_alt', true);
        $alt = !empty($alt0) ? $alt0 : $attachment->post_title;
        $lrg_img = wp_get_attachment_image_src($attachment->ID, 'full');
        if ($width != 0) {
            $resize = aq_resize($lrg_img[0], $width, $height, true);
        }
        $url = !empty($resize) ? $resize : $lrg_img[0];
        if(!$returnURL){
            return '<img src="' . $url . '" alt="' . $alt . '"/>';
        } else {
            return $url;
        }
    }
}

// ThemeWaves Pagination

function waves_pagination() {
    global $wp_query;
    $pages = $wp_query->max_num_pages;
    if (empty($pages)) {
        $pages = 1;
    }
    if ( get_query_var('paged') ) {
        $paged = get_query_var('paged');
    } elseif ( get_query_var('page') ) {
        $paged = get_query_var('page');
    } else {
        $paged = 1;
    }
    
    if (1 != $pages) {
        $big = 9999; // need an unlikely integer
        echo "<div class='waves-pagination'>";
            $pagination = paginate_links(
                array(
                    'base' => str_replace($big, '%#%', esc_url(get_pagenum_link($big))),
                    'end_size' => 3,
                    'mid_size' => 6,
                    'format' => '?paged=%#%',
                    'current' => max(1, $paged),
                    'total' => $pages,
                    'type' => 'list',
                    'prev_text' => __('&laquo;', 'waves'),
                    'next_text' => __('&raquo;', 'waves'),
                )
            );
            echo $pagination;
        echo "</div>";
    }
}

function waves_blogcontent($atts) {
    global $more;
    $more = 0;    

    if (!empty($atts['excerpt_count'])) {
        echo apply_filters("the_excerpt", waves_excerpt(strip_shortcodes(get_the_content()), $atts['excerpt_count']));
    }elseif (has_excerpt()) {
        the_excerpt();
    } elseif (waves_has_more()) {
        the_content("");
    } else {
        echo apply_filters("the_excerpt", get_the_content(""));
    }
}

function waves_excerpt($str, $length) {
    $str = explode(" ", strip_tags($str));
    return implode(" ", array_slice($str, 0, $length));
}

function waves_has_more() {
    global $post;
    if (empty($post))
        return;
    return (bool) preg_match('/<!--more(.*?)?-->/', $post->post_content);
}



function waves_comment_count() {
//        if (tw_option('facebook_comment')) {
//            return '<fb:comments-count data-href="' . get_permalink() . '"></fb:comments-count>';
//        } else {
            $comment_count = get_comments_number('0', '1', '%');
            if ($comment_count == 0) {
                $comment_trans = __('No comment', 'waves');
            } elseif ($comment_count == 1) {
                $comment_trans = __('One comment', 'waves');
            } else {
                $comment_trans = $comment_count . ' ' . __('comments', 'waves');
            }
            return "<a href='" . get_comments_link() . "' title='" . $comment_trans . "'>" . $comment_trans . "</a>";
//        }
}

function waves_item($atts,$class='',$data='',$style=''){
    wp_enqueue_style('waves-animate', WAVES_DIR . 'assets/css/animate-custom.css');
    if(!empty($atts['layout_size'])&&$atts['layout_size'] === 'col-md-3'){
        $atts['size'] = 'col-md-12';
    }
    if(!empty($atts['size'])){
        $class.= ' '.$atts['size'];
    }
    if(!empty($atts['class'])){
        $class.= ' '.$atts['class'];
    }
    $animated=false;
    if (isMobile() && !tw_option('mobile_animation')) {
        $atts['animation'] = 'none';
    }
    if(isset($atts['animation'])&&$atts['animation']!=='none'){
        $animated=true;
        $class .= ' tw-animate-gen';
        $atts['animation_delay'] = empty($atts['animation_delay']) ? '0': str_replace(' ','',$atts['animation_delay']);
        $style .='opacity:0;';
        $data.='data-animation="'.$atts['animation'].'" data-animation-delay="'.$atts['animation_delay'].'" data-animation-offset="90%"';
    }
//    else{
//        $data.='data-animation="none"';
//    }
    
    $output = '<div class="tw-element ' .$class. '" style="'.$style.'" '.$data.'>';
    if(!empty($atts['title'])){
        $output .= '<div class="waves-title"><h3>' . rawUrlDecode($atts['title']) . '</h3><div class="title-bg"></div></div>';
    }
    return $output;
}

add_shortcode('tw_item_title', 'waves_item_title');
function waves_item_title($atts, $content){
    $atts = shortcode_atts(array(
        'title' => '',
    ), $atts);
    $output = '<div class="waves-title"><h3>' . rawUrlDecode($atts['title']) . '</h3><div class="title-bg"></div></div>';
    return $output;
}


function waves_like(){
    global $post;
    $likeit = get_post_meta($post->ID, 'post_likeit', true);
    $likecount = empty($likeit) ? '0' : $likeit;
    $likedclass = 'likeit';
    if (isset($_COOKIE['likeit-' . $post->ID])) {
        $likedclass .= ' liked';
    }
    $output = '<div data-ajaxurl="'.home_url().'" data-pid="'.$post->ID.'" class="'.$likedclass.'">';
        $output .= '<i class="fa fa-heart-o"></i><span>'.$likecount.(is_single() ? __(' Likes', 'themewaves') : ''). '</span>';
    $output .= '</div>';
    return $output;
}


if (isset($_REQUEST['liked_pid'])) {
    $pid = intval($_REQUEST['liked_pid']);
    $liked = get_post_meta($pid, 'post_likeit', true);
    if (!isset($_COOKIE['likeit-' . $pid])) {
        if (empty($liked)) {
            $liked = 1;
        } else {
            $liked = (intval($liked) + 1);
        }
        update_post_meta($pid, 'post_likeit', $liked);
        setcookie('likeit-' . $pid, 1);
    }
    print "<div><div id='portfolio_liked'>$liked</div></div>";
    die;
}